// --------------------------------------------------
// MCMC step with candidate and present point
void mcmc_move()
{
  if(chi2[ind_new] <= chi2[ind_old])
    //Block: if it moves directly because higher probability
    {
      move_flag = true;
      // check if it improves bestfit point
      if (chi2[ind_old] <= chi2_bestfit){new_bestfit_point(ind_old);}
    }
  else
    {
      //Block: having lower probability, random decision
      double ran = gsl_rng_uniform (r);
      //Compute candidate probability
      if(ran <= ( prob[ind_new] / prob[ind_old] ) )
	{
	  // Moves
	  move_flag = true;
	}
      else
	{
	  // Stays
	  move_flag = false;
	}
    }

}
// --------------------------------------------------
// MCMC step with candidate and present point
void mcmc_move_heat()
{
  // check if it improves bestfit point for regular chi2
  if (chi2[ind_old] <= chi2_bestfit){new_bestfit_point(ind_old);}

  if(chi2_heat[ind_new] <= chi2_heat[ind_old])
    //Block: if it moves directly because higher probability
    {
      move_flag = true;
    }
  else
    {
      //Block: having lower probability, random decision
      double ran = gsl_rng_uniform (r);
      //Compute candidate probability
      if(ran <= ( prob_heat[ind_new] / prob_heat[ind_old] ) )
	{
	  // Moves
	  move_flag = true;
	}
      else
	{
	  // Stays
	  move_flag = false;
	}
    }

}
// --------------------------------------------------
 
