// --------------------------------------------------
// good
//template <typename T,unsigned S>
//inline signed arraysize(const T (&v)[S]) { return S; }
template <typename T,signed S>
inline signed arraysize(const T (&v)[S]) { return S; }
// --------------------------------------------------
// --------------------------------------------------
// fº returns a string with result from system call
// Primitive!
string get_from_command(string command)
{
  string s_result;
  int result_digits = 0;

  // First call to set the appropriate string length (without blanks)
  {
    int result_digits0 = 500; // default sufficiently large to hold the string
    // BEGIN: get result from system shell call
    FILE *open_pt0;
    char num_result_c0[result_digits0];
    // system shell call with popen to retrieve result
    open_pt0 = popen(command.c_str(), "r");
    fgets(num_result_c0, sizeof(num_result_c0), open_pt0);
    pclose(open_pt0);
    // END: get result from system shell call
  
    while (num_result_c0[result_digits] != '\0') {result_digits++;} // count non null digits to establish the length
  }

  // Second call to return the string
  char num_result_c[result_digits];
  FILE *open_pt;
  open_pt = popen(command.c_str(), "r");
  fgets(num_result_c, sizeof(num_result_c), open_pt);
  pclose(open_pt);
  s_result = num_result_c;
  return s_result;
}
// --------------------------------------------------
// fº returns a string with time returned from system call, uses get_from_command
string get_time(string time_command="date +%G%m%d-%H%M%S") // default format of the date YYYYMMDD-hhmmss
{
  return get_from_command(time_command);
}
// --------------------------------------------------
// fº returns a string with the path returned from system call, uses get_from_command
string get_path(string path_command="pwd")
{
  return get_from_command(path_command);
}
// --------------------------------------------------
// 
// --------------------------------------------------
//--------------------------------------------------
// Probability
inline obs probab(obs chi2_case)
{
  return exp(-0.5*chi2_case);
}
// --------------------------------------------------
//--------------------------------------------------

// --------------------------------------------------
obs_c f_triangle(double x)
{
  if (x>=1.0)
    {return pow(asin(1.0/sqrt(x)),2);}
  else
    {obs_c temp; temp.real()=log((1.0+sqrt(1.0-x))/(1.0-sqrt(1.0-x))); temp.imag()=-M_PI; return -0.25*temp*temp;}
}

// --------------------------------------------------
obs_c AF(double x)
{
  return -2.0*x*(1.0+(1.0-x)*f_triangle(x)); 
}
// --------------------------------------------------

// --------------------------------------------------
obs_c AFhat(double x)
{
  return -2.0*x*f_triangle(x); 
}
// --------------------------------------------------

// --------------------------------------------------
obs_c AV(double x)
{
  return 2.0+3.0*x+3.0*x*(2.0-x)*f_triangle(x); 
}
// --------------------------------------------------

// --------------------------------------------------
obs_c AS(double x)
{
  return x*(1.0-x*f_triangle(x)); 
}
// --------------------------------------------------

// --------------------------------------------------
obs F_oblique(double X, double Y)
{
  if( abs(1.0-X/Y) < 1.0e-6 )
    {return 0.0;}
  else
    {
      return 0.5*(X+Y) - X*Y*log(X/Y)/(X-Y);
    }
}
// --------------------------------------------------
obs f_oblique(double x, double y)
{
  double t, r, temp;
  t = x+y-1.0; r = 1-2.0*(x+y)+(x-y)*(x-y);
  if( abs(x-y) < 1.0e-6 )
    {
      if (x > 0.25) {temp=sqrt(4.0*x-1.0); return 2.0*temp*atan(temp/(2.0*x-1));}
      else {temp=sqrt(1.0-4.0*x); return temp*log((1.0-2.0*x+temp)/(1.0-2.0*x-temp));}
    }
  else
    {
      if(r>0) {temp=sqrt(r); return temp*log( abs( (t-temp)/(t+temp) ) );}
      else {temp=sqrt(-r); return 2.0*temp*atan(temp/t);}
    }
}
// --------------------------------------------------

// --------------------------------------------------
obs G_oblique(double x, double y)
{
  if( abs(x-y) < 1.0e-6 )
    {
      return -16.0/3.0+16.0*x+(1.0-4.0*x)*f_oblique(x,y);
    }
  else
    {
      return -16.0/3.0+ 5.0*(x+y)-2.0*pow(x-y,2)+( 3.0*(x*x+y*y)/(x-y) - 3.0*(x*x-y*y) + pow(x-y,3) )*log(x/y) + ( 1.0 - 2.0*(x+y) + pow(x-y,2) )*f_oblique(x,y);
    }
}
// --------------------------------------------------

// --------------------------------------------------
obs Gtilde_oblique(double x, double y)
{
  if( abs(x-y) < 1.0e-6 )
    {
      return -4.0+f_oblique(x,y);
    }
  else
    {
      return -2.0+( x-y - (x+y)/(x-y) )*log(x/y)+f_oblique(x,y);
    }
}
// --------------------------------------------------

// --------------------------------------------------
obs Ghat_oblique(double x, double z)
{
  return G_oblique(x/z,1.0)+12.0*Gtilde_oblique(x/z,1.0);
}
// --------------------------------------------------

// --------------------------------------------------
obs A0_Scalar(double x)
{
  return (2.0+3.0*x-6.0*x*x+x*x*x+6.0*x*log(x))/24.0/pow(1.0-x,4);
}
// --------------------------------------------------
obs A1_Scalar(double x)
{
  return (-3.0+4.0*x-x*x-2.0*log(x))/4.0/pow(1.0-x,3);
}
// --------------------------------------------------
obs A2_Scalar(double x)
{
  return (-7.0+5.0*x+8.0*x*x)/36.0/pow(1.0-x,3)+x*(-2.0+3.0*x)*log(x)/6.0/pow(1.0-x,4);

}
// --------------------------------------------------
obs A3_Scalar(double x)
{
  return (-3.0+8.0*x-5.0*x*x-(4.0-6.0*x)*log(x))/6.0/pow(1.0-x,3);
}
// --------------------------------------------------
obs Dipole_I2(double x)
{
  if (x < 0.01){ return -x*(1.5+log(x))-x*x*(16.0/3.0+4.0*log(x));}
  else
    {
      obs temp;
      if(x<0.25){temp=sqrt(1.0-4.0*x); return 1.0+log(x)/2.0/x+(1.0-2.0*x)/(2.0*x*temp)*log((1.0+temp)/(1.0-temp));}
      else {temp=sqrt(4.0*x-1); return 1.0+log(x)/2.0/x+(1.0-2.0*x)/(x*temp)*atan(temp);}
    }
}
// --------------------------------------------------
obs Dipole_I3(double x)
{
  if (x < 0.01){ return -x*(11.0/6.0+log(x))-x*x*(89.0/12.0+5.0*log(x));}
  else
    {
      obs temp;
      if(x<0.25){temp=sqrt(1.0-4.0*x); return 0.5+1.0/x+(1.0-x)*log(x)/2.0/x/x+(1.0-3.0*x)/(2.0*x*x*temp)*log((1.0+temp)/(1.0-temp));}
      else {temp=sqrt(4.0*x-1); return 0.5+1.0/x+(1.0-x)*log(x)/2.0/x/x+(1.0-3.0*x)/(x*x*temp)*atan(temp);}
    }
}
// --------------------------------------------------
obs Dipole_J(double x)
{
  if (x < 0.01){ return x/6.0+x*x/12.0;}
  else{ return -0.5+1.0/x-(x-1.0)/x/x*log(1.0-x);}
}
// --------------------------------------------------

// --------------------------------------------------
obs f_BarrZee(double x)
{
  obs lx = log(x);
  return exp( -0.189745 + 0.295492 * lx - 0.0459405 * lx * lx - 0.0019027 * pow(lx,3) - 4.22181e-05 * pow(lx,4) - 3.81631e-07 * pow(lx,5) );
}
// --------------------------------------------------
obs g_BarrZee(double x) 
{
  obs lx = log(x);
  return exp( 0.159181 + 0.31108 * lx - 0.0473163 * lx * lx - 0.00206831 * pow(lx,3) - 4.81357e-05 * pow(lx,4) - 4.5338e-07 * pow(lx,5) );
}
// --------------------------------------------------

// --------------------------------------------------
obs PhaseSpace_f(double x)
{
  return 1.0 - 8.0*x + 8.0*pow(x,3) - pow(x,4) - 12.0*pow(x,2)*log(x);
}
obs PhaseSpace_g(double x)
{
  return 1.0 + 9.0*x - 9.0*pow(x,2) - pow(x,3) + 6.0*x*(1.0+x)*log(x);
}
// --------------------------------------------------

// --------------------------------------------------
obs Scalar_Decay_Fermions(double M0, double m1, double m2, double Cs, double Cp)
{
  if ( M0 <= m1 + m2 ){ return 0.0;}
  else
    {
      return M0 / 8.0 / M_PI * ( pow(Cs,2) * pow( 1.0 - pow( (m1+m2)/M0, 2) , 1.5) + pow(Cp,2) * pow( 1.0 - pow( (m1-m2)/M0, 2) , 1.5) );
    }
}
// ----------
obs Scalar_Decay_Scalars(double M0, double m1, double m2, double C)
{
  if ( M0 <= m1 + m2 ){ return 0.0;}
  else
    {
      return 1.0 / M0 / 16.0 / M_PI * pow(C,2) * sqrt( ( 1.0 - pow( (m1+m2)/M0, 2)) * ( 1.0 - pow( (m1-m2)/M0, 2) ) );
    }
}
// ----------
obs Scalar_Decay_Vectors(double M0, double Mv, double c)
{
  if ( M0 <= 2.0 * Mv ) { return 0.0;}
  else
    {
      return pow(c,2)*pow(M0,3)/pow(Mv,4) / 64.0 / M_PI * sqrt( 1.0 - pow(2.0*Mv/M0, 2) ) * ( 1.0 - pow(2.0*Mv/M0, 2) + 12.0 * pow(Mv/M0, 4) );
    }
}
// ----------
obs Scalar_Decay_ScalarVector(double M0, double Ms, double Mv, double c)
{
  if ( M0 <= Ms + Mv ){ return 0.0;}
  else
    {
      return pow(c,2)*pow(M0,3)/pow(Mv,2)* pow( 1.0-pow((Ms+Mv)/M0,2), 1.5) * pow( 1.0-pow((Ms-Mv)/M0,2),1.5) / 16.0 / M_PI;
    }
}
// --------------------------------------------------
obs Decay_3body_0(double M0, double m1, double m2, double m3, double c2, int steps)
{
  if ( M0 <= m1+m2+m3 ) { return 0.0;}
  else
    {
      double m122_min = pow(m1+m2,2);
      double m122_max = pow(M0-m3,2);
      double m122_step = (m122_max-m122_min)/steps;
      double m122, res = 0.0;
      for(int i=0; i<steps; i++)
	{
	  m122 = m122_min + (i+0.5)*m122_step;
	  res += m122_step * sqrt(pow(m122-m1*m1+m2*m2,2)-4.0*m122*m2*m2)*sqrt(pow(M0*M0-m122-m3*m3,2)-4.0*m122*m3*m3)/m122;
	}
      return 3.0 * res * c2 / 256.0 / pow(M0*M_PI,3);
    }
}
// ----------
obs Decay_3body_1(double M0, double m1, double m2, double m3, double c2, int steps)
{
  if ( M0 <= m1+m2+m3 ) { return 0.0;}
  else
    {
      double m122_min = pow(m1+m2,2);
      double m122_max = pow(M0-m3,2);
      double m122_step = (m122_max-m122_min)/steps;
      double m122, res = 0.0;
      for(int i=0; i<steps; i++)
        {
          m122 = m122_min + (i+0.5)*m122_step;
          res += m122_step * sqrt(pow(m122-m1*m1+m2*m2,2)-4.0*m122*m2*m2)*sqrt(pow(M0*M0-m122-m3*m3,2)-4.0*m122*m3*m3)/m122 * (2.0 + 0.5*pow(m1/m2+m2/m1,2) - (1.0/m2/m2+1.0/m1/m1)*m122 + 0.5*pow(m122/m1/m2,2));
        }
      return res * c2 / 256.0 / pow(M0*M_PI,3);
    }
}
// --------------------------------------------------

// --------------------------------------------------
obs alpha_QED(double a_ref, double m2_ref, double q2)
{
  return a_ref/(1.0 - a_ref * 20.0 / 9.0 / M_PI * log(q2/m2_ref));
}
// --------------------------------------------------

// --------------------------------------------------
obs MassProp_Re(double q2, double Mass)
{
  return q2 - Mass*Mass;
}
obs MassProp_Im(double q2, double Mass, double Width)
{
  return q2*Width/Mass;
}
obs MassProp_Mod2(double q2, double Mass, double Width)
{
  return 1.0 / ( pow(MassProp_Re(q2,Mass), 2) + pow(MassProp_Im(q2, Mass, Width), 2) );
}
// --------------------------------------------------
obs CrossSection_EW_epem_to_lplm(double ECM, double cos_p, double cos_m, double C_Gamma, double C_Z, double MZ, double GZ, double CV_e, double CA_e, double CV_m, double CA_m)
{
  obs temp = 0.0, s = pow(ECM,2);
  temp += pow(C_Gamma,2) * M_PI / 2.0 / s * (cos_p-cos_m + (pow(cos_p,3)-pow(cos_m,3))/3.0);
  //  temp += pow(C_Z,2) * s * MassProp_Mod2(s, MZ, GZ) / 32.0 / M_PI * ( (CV_e*CV_e+CA_e*CA_e)*(CV_m*CV_m+CA_m*CA_m)*(cos_p-cos_m + (pow(cos_p,3)-pow(cos_m,3))/3.0) + 4.0 * CV_e*CA_e*CV_m*CA_m*(pow(cos_p,2)-pow(cos_m,2)) );
  //  temp += C_Gamma*C_Z*MassProp_Re(s, MZ) * MassProp_Mod2(s, MZ, GZ)/4.0 * ( CV_e*CV_m*(cos_p-cos_m + (pow(cos_p,3)-pow(cos_m,3))/3.0) + CA_e*CA_m*(pow(cos_p,2)-pow(cos_m,2)) );
  return temp;
}
// -----
obs CrossSection_2Scalars_epem_to_lplm(double ECM, double cos_p, double cos_m, double MS1, double GS1, double CS1_e, double CP1_e, double CS1_m, double CP1_m, double MS2, double GS2, double CS2_e, double CP2_e, double CS2_m, double CP2_m)
{
  obs temp = 0.0, s = pow(ECM,2);
  temp += 1.0 / 16.0 / M_PI * s * (MassProp_Re(s, MS1)*MassProp_Re(s, MS2)+MassProp_Im(s, MS1, GS1)*MassProp_Im(s, MS2, GS2))*MassProp_Mod2(s, MS1, GS1)*MassProp_Mod2(s, MS2, GS2)* (CS1_e*CS2_e+CP1_e*CP2_e)*(CS1_m*CS2_m+CP1_m*CP2_m) * (cos_p-cos_m);
  return temp;
}
obs CrossSection_1Scalar_epem_to_lplm(double ECM, double cos_p, double cos_m, double MS, double GS, double CS_e, double CP_e, double CS_m, double CP_m)
{
  obs temp = 0.0, s = pow(ECM,2);
  temp += 1.0 / 32.0 / M_PI * s * MassProp_Mod2(s, MS, GS)*(pow(CS_e,2)+pow(CP_e,2))*(pow(CS_m,2)+pow(CP_m,2)) * (cos_p-cos_m);
  return temp;
}
// --------------------------------------------------
obs S_WW(double x_tW)
{
  return 1.0 + 9.0 / (1.0 - x_tW) - 6.0 / pow(1.0 - x_tW, 2) - 6.0 * log(x_tW) * x_tW*x_tW/pow(1.0 - x_tW, 3);
}
obs S_WH(double x_tW, double x_tH, double x_HW)
{
  return x_tH * ( (2.0*x_HW-8.0)*log(x_tH)/(1.0-x_HW)/pow(1.0-x_tH,2)+6.0*x_HW*log(x_tW)/(1.0-x_HW)/pow(1.0-x_tW,2)-(8.0-2.0*x_tW)/(1.0-x_tW)/(1.0-x_tH) );
}
obs S_HH(double x_tH)
{
  return x_tH * ( (1.0+x_tH)/pow(1.0-x_tH,2) + 2.0*x_tH*log(x_tH)/pow(1.0-x_tH,3) );
}
// --------------------------------------------------
obs typeII_tb1_ChHtb_xS(obs m) // Charged Higgs+tb  production cross section in 2HDM type II for tanbeta=1 at LHC 13TeV
{
  return pow(10.0, 3.0 + 1.37378 - m*4.72148e-3 + pow(m,2)*2.4663e-06 - pow(m,3)*9.64044e-10 + pow(m,4)*1.56372e-13);
}
