//--------------------------------------------------
// Compute observables & chi2 for the candidate point
void model_calculations(int ind_case)
{
  valid_point = true;

  not_ind_case = (ind_case + 1) % 2;

  // --------------------------------------------------
   b_nle[ind_case]=0.0;
   b_nlm[ind_case]=0.0;
   b_nlt[ind_case]=0.0;


#include "../../myphyslib/2HDM-glFC/scalar-sector-SSB.h"

  // --------------------------------------------------

#include "../../myphyslib/2HDM-glFC/scalarsector-bounded.h"

  // --------------------------------------------------
      
  // -------------------------
  if(!valid_point)
    {chi2[ind_case] = chi2_Lcut;}
  else 
    {// BEGIN chi2

#include "../../myphyslib/2HDM-glFC/scalarsector-constraints.h"

      // --------------------------------------------------

      //      arg_n_le[ind_case]=-M_PI/2.0;
      //      arg_n_le[ind_case]=M_PI/2.0;
      //      arg_n_le[ind_case]=M_PI;
      //      arg_n_le[ind_case]=0.0;

#include "../../myphyslib/2HDM-glFC/typeI-fermioncouplings.h"

      // test
      //      re_n_le=m_le;im_n_le=0.0;
      //      re_n_lm=m_lm;im_n_lm=0.0;
      //      re_n_lt=m_lt;im_n_lt=0.0;
      // -------------------------

#include "../../myphyslib/2HDM-glFC/fermionscalar-couplings.h"

#include "../../myphyslib/2HDM-glFC/higgs-constraints.h"

#include "../../myphyslib/2HDM-glFC/treelevel-chargedscalar.h"


      // -------------------------
      // Dipoles
#include "../../myphyslib/2HDM-glFC/dipoles_2.h"
      // -------------------------

#include "../../myphyslib/2HDM-glFC/yukawa-perturbativity.h"

#include "../../myphyslib/2HDM-glFC/scalar-widths.h"

#include "../../myphyslib/2HDM-glFC/LEP-dileptons.h"

      // --------------------------------------------------
      // LHC Scalar -> dileptons
#include "../../myphyslib/2HDM-glFC/LHC_scalar-dileptons.h"
      // LHC Charged scalar
#include "../../myphyslib/2HDM-glFC/LHC_scalar-charged.h"


      // --------------------------------------------------
      G_H[ind_case] = log10(G_H[ind_case]/m_H[ind_case]);
      G_A[ind_case] = log10(G_A[ind_case]/m_A[ind_case]);
      G_ChH[ind_case] = log10(G_ChH[ind_case]/m_ChH[ind_case]);
      // -----
      BR_H_lele[ind_case] = log10(BR_H_lele[ind_case]);
      BR_H_lmlm[ind_case] = log10(BR_H_lmlm[ind_case]);
      BR_H_ltlt[ind_case] = log10(BR_H_ltlt[ind_case]);
      if (BR_H_qtqt[ind_case]>1.0e-10){BR_H_qtqt[ind_case] = log10(BR_H_qtqt[ind_case]);} else {BR_H_qtqt[ind_case] = -10.0;}
      BR_H_qbqb[ind_case] = log10(BR_H_qbqb[ind_case]);
      BR_A_lele[ind_case] = log10(BR_A_lele[ind_case]);
      BR_A_lmlm[ind_case] = log10(BR_A_lmlm[ind_case]);
      BR_A_ltlt[ind_case] = log10(BR_A_ltlt[ind_case]);
      if (BR_A_qtqt[ind_case]>1.0e-10){BR_A_qtqt[ind_case] = log10(BR_A_qtqt[ind_case]);} else {BR_A_qtqt[ind_case] = -10.0;}
      BR_A_qbqb[ind_case] = log10(BR_A_qbqb[ind_case]);
      BR_ChH_qtqb[ind_case] = log10(BR_ChH_qtqb[ind_case]);
      BR_ChH_ltnu[ind_case] = log10(BR_ChH_ltnu[ind_case]);
      BR_ChH_lmnu[ind_case] = log10(BR_ChH_lmnu[ind_case]);
      BR_ChH_lenu[ind_case] = log10(BR_ChH_lenu[ind_case]);
      if (BR_A_HZ[ind_case]>1.0e-10){BR_A_HZ[ind_case]=log10(BR_A_HZ[ind_case]);} else {BR_A_HZ[ind_case]=-10.0;}
      if (BR_ChH_HW[ind_case]>1.0e-10){BR_ChH_HW[ind_case]=log10(BR_ChH_HW[ind_case]);} else {BR_ChH_HW[ind_case]=-10.0;}
      // --------------------------------------------------


#include "../../myphyslib/2HDM-glFC/bsgamma.h"

#include "../../myphyslib/2HDM-glFC/mesonmixing_chargedbox.h"


      chi2[ind_case] = 0.0;


      // --------------------------------------------------
      chi2[ind_case] += chi2_yukawa_pert[ind_case] + chi2_2HDMScalar_pert[ind_case] + chi2_2HDMScalar_pert_unit[ind_case] + chi2_ScalarMasses[ind_case] + chi2_Oblique[ind_case] + chi2_Higgs[ind_case] + chi2_dipoles[ind_case] + chi2_bsgamma[ind_case] + chi2_tree_Charged[ind_case] + chi2_LEP_eemm[ind_case] + chi2_LEP_eett[ind_case] + chi2_LHC_ll[ind_case] + chi2_LHC_ChH[ind_case] + chi2_mesonmixing[ind_case];
      // --------------------------------------------------

      // temp for examples
      //      chi2[ind_case] += pow(a_nlm[ind_case] + 95.0,2);


    }// END chi2
    // --------------------------------------------------
    
    //  chi2[ind_case] = sqrt(chi2[ind_case]);
    /*  
	chi2_Smps[ind_case] = 1.0;
	dchi2_Smps[ind_case] = abs(chi2_Smps[ind_case] - chi2_Smps[not_ind_case]);
    */

  
  // Cutoff
  if(chi2[ind_case]>1.0e20*chi2_Lcut) {chi2[ind_case]=chi2_Lcut;}
  
  // Finally the probability
  prob[ind_case] = probab(chi2[ind_case]);

}
//--------------------------------------------------
// Compute observables & chi2 for the candidate point
void model_calculations_heat(int ind_case)
{
  model_calculations(ind_case);
  chi2_heat[ind_case] = 0.30 * chi2[ind_case] + 5.0 * chi2_dipoles[ind_case];
  //  if(chi2[ind_case]<40.0){chi2_heat[ind_case] = 33.0;}
  //  else {chi2_heat[ind_case] = 33.0 + 3.0 * (chi2[ind_case]-40.0);}

  //  chi2_heat[ind_case] += min( pow( abs(log10_tanbeta[ind_new]-log10(200.0))/0.1,2) + pow( abs(a_nle[ind_new]-60.0)/2.0,2), min( pow( abs(log10_tanbeta[ind_new]-log10(300.0))/0.1,2) + pow( abs(a_nle[ind_new]-59.0)/2.0,2), pow( abs(log10_tanbeta[ind_new]-log10(300.0))/0.1,2) + pow( abs(a_nle[ind_new]-50.0)/2.0,2) ) );
  //  chi2_heat[ind_case] = 0.10 * chi2[ind_case];

  //  chi2_heat[ind_case] += pow( (m_A[ind_case]-200.0)/50.0,2);
  //  chi2_heat[ind_case] += pow( (m_ChH[ind_case]-200.0)/50.0,2);
  //  chi2_heat[ind_case] += pow( (log10_tanbeta[ind_new]-3.0)/0.1,2);
  //  chi2_heat[ind_case] += pow( (a_nle[ind_new]-80.0)/10.0,2);
  //  chi2_heat[ind_case] += pow( (a_nlm[ind_new]+50.0)/10.0,2);

  prob_heat[ind_case] = probab(chi2_heat[ind_case]);
}
