//--------------------------------------------------
// Compute observables & chi2 for the candidate point
void model_calculations(int ind_case)
{
  valid_point = true;

  not_ind_case = (ind_case + 1) % 2;

  // --------------------------------------------------

  // --------------------------------------------------
  // Rotation scalar sector
  c[0]=sin(rot_ba[ind_case]); s[0]=-cos(rot_ba[ind_case]);
  //  c[0]=1.0; s[0]=0.0;
  c[1]=1.0; s[1]=0.0;
  c[2]=1.0; s[2]=0.0;
  ROT[0][0]=c[0]*c[1]; ROT[0][1]=s[0]*c[1]; ROT[0][2]=s[1];
  ROT[1][0]=-s[0]*c[2]-c[0]*s[1]*s[2]; ROT[1][1]=c[0]*c[2]-s[0]*s[1]*s[2]; ROT[1][2]=c[1]*s[2];
  ROT[2][0]=s[0]*s[2]-c[0]*s[1]*c[2]; ROT[2][1]=-c[0]*s[2]-s[0]*s[1]*c[2]; ROT[2][2]=c[1]*c[2];
  // --------------------------------------------------

  // --------------------------------------------------
  // Couplings of the Higgs
  R11[ind_case]=ROT[0][0];
  R21[ind_case]=log10(abs(ROT[1][0]));
  if(R21[ind_case]<-4.0){R21[ind_case]=0.0;}
  else
    {
      if(ROT[1][0]<0.0){R21[ind_case]=-4.0-R21[ind_case];}
      if(ROT[1][0]>0.0){R21[ind_case]=4.0+R21[ind_case];}
    }
  //  R31[ind_case]=ROT[2][0];
  // --------------------------------------------------

  // --------------------------------------------------
  // beta
  beta = atan(pow(10.0, log10_tanbeta[ind_case]));
  cb = cos(beta); sb = sin(beta); tb = sb/cb;
  // --------------------------------------------------

  // --------------------------------------------------
  // Quantities in the scalar sector
  // --------------------------------------------------
  mH2=pow(m_H[ind_case],2);
  mA2=pow(m_A[ind_case],2);
  mChH2=pow(m_ChH[ind_case],2);

  // Mass matrix
  M2_12 = mh2 * ROT[0][0] * ROT[1][0] + mH2 * ROT[0][1] * ROT[1][1] + mA2 * ROT[0][2]* ROT[1][2];
  M2_13 = mh2 * ROT[0][0] * ROT[2][0] + mH2 * ROT[0][1] * ROT[2][1] + mA2 * ROT[0][2]* ROT[2][2];
  M2_23 = mh2 * ROT[1][0] * ROT[2][0] + mH2 * ROT[1][1] * ROT[2][1] + mA2 * ROT[1][2]* ROT[2][2];
  M2_11 = mh2 * ROT[0][0] * ROT[0][0] + mH2 * ROT[0][1] * ROT[0][1] + mA2 * ROT[0][2]* ROT[0][2];
  M2_22 = mh2 * ROT[1][0] * ROT[1][0] + mH2 * ROT[1][1] * ROT[1][1] + mA2 * ROT[1][2]* ROT[1][2];
  M2_33 = mh2 * ROT[2][0] * ROT[2][0] + mH2 * ROT[2][1] * ROT[2][1] + mA2 * ROT[2][2]* ROT[2][2];

  // Invert lambdas
  lambda_5[ind_case] = -mA2 / 2.0 / VEV2;
  lambda_1[ind_case] = (mh2+mH2+(mH2-mh2)*cos(2.0*(rot_ba[ind_case]-beta)))/4.0/VEV2/cb/cb;
  lambda_2[ind_case] = (mh2+mH2-(mH2-mh2)*cos(2.0*(rot_ba[ind_case]-beta)))/4.0/VEV2/sb/sb;
  lambda_3[ind_case] = ((mh2-mH2)*sin(2.0*(rot_ba[ind_case]-beta))/2.0/cb/sb+2.0*mChH2)/2.0/VEV2;
  lambda_4[ind_case] = (mA2-2.0*mChH2)/2.0/VEV2;
  /*
  l345 = (mh2-mH2)*sin(2.0*(rot_ba[ind_case]-beta))/4.0/VEV2/cb/sb;
  lambda_4[ind_case] = lambda_5[ind_case] - mChH2/VEV2;
  lambda_3[ind_case] = l345 - lambda_4[ind_case] + lambda_5[ind_case];
  */
  l1 = lambda_1[ind_case]; l2 = lambda_2[ind_case]; l3 = lambda_3[ind_case]; l4 = lambda_4[ind_case]; rl5 = lambda_5[ind_case]; il5 = 0.0;
  // --------------------------------------------------

  // --------------------------------------------------

  // Valid point conditions
  if(lambda_1[ind_case] < 0.0){valid_point=false;}
  if(lambda_2[ind_case] < 0.0){valid_point=false;}

  if(valid_point)
    {
      if(sqrt(lambda_1[ind_case]*lambda_2[ind_case]) < -lambda_3[ind_case]){valid_point=false;}
    }

  if(valid_point)
    {
      if(sqrt(lambda_1[ind_case]*lambda_2[ind_case]) < abs(lambda_5[ind_case])-lambda_3[ind_case]-lambda_4[ind_case]){valid_point=false;}
    }

  // Global minimmum
  if(valid_point)
    {
      if( ( pow(mChH2/VEV2 + lambda_4[ind_case], 2)-pow(abs(lambda_5[ind_case]), 2) ) * ( mChH2/VEV2 + sqrt(lambda_1[ind_case]*lambda_2[ind_case]) - lambda_3[ind_case] ) < 0.0 ){valid_point = false;}
    }


  // --------------------------------------------------
      
  // -------------------------
  if(!valid_point)
    {chi2[ind_case] = chi2_Lcut;}
  else 
    {// BEGIN chi2
      chi2[ind_case] = 0.0;
      chi2_2HDMScalar_pert[ind_case] = 0.0;
      chi2_2HDMScalar_pert_unit[ind_case] = 0.0;

      // -------------------------
      // Perturbativity in the scalar sector / Simple 1
      if(abs(lambda_1[ind_case]) > pert_bound_val)
	{chi2_2HDMScalar_pert[ind_case] += pow( (abs(lambda_1[ind_case]) - pert_bound_val)/pert_bound_unc, 2);}
      if(abs(lambda_2[ind_case]) > pert_bound_val)
	{chi2_2HDMScalar_pert[ind_case] += pow( (abs(lambda_2[ind_case]) - pert_bound_val)/pert_bound_unc, 2);}
      if(abs(lambda_3[ind_case]) > pert_bound_val)
	{chi2_2HDMScalar_pert[ind_case] += pow( (abs(lambda_3[ind_case]) - pert_bound_val)/pert_bound_unc, 2);}
      if(abs(lambda_4[ind_case]) > pert_bound_val)
	{chi2_2HDMScalar_pert[ind_case] += pow( (abs(lambda_4[ind_case]) - pert_bound_val)/pert_bound_unc, 2);}
      if(abs(lambda_5[ind_case]) > pert_bound_val)
	{chi2_2HDMScalar_pert[ind_case] += pow( (abs(lambda_5[ind_case]) - pert_bound_val)/pert_bound_unc, 2);}
      /*
      if(abs(lambda_6[ind_case]) > pert_bound_val)
	{chi2_2HDMScalar_pert[ind_case] += pow( (abs(lambda_6[ind_case]) - pert_bound_val)/pert_bound_unc, 2);}
      if(abs(lambda_7[ind_case]) > pert_bound_val)
	{chi2_2HDMScalar_pert[ind_case] += pow( (abs(lambda_7[ind_case]) - pert_bound_val)/pert_bound_unc, 2);}
      */
      // Perturbativity Scattering,eigenvalues
      temp = abs( lambda_1[ind_case]+lambda_2[ind_case] + sqrt( pow(lambda_1[ind_case]-lambda_2[ind_case],2) + pow(2.0*lambda_5[ind_case],2) ) );
      if( temp > pert_unit_bound_val){chi2_2HDMScalar_pert_unit[ind_case] += pow( (temp - pert_unit_bound_val)/pert_unit_bound_unc, 2);}
      temp = abs( lambda_1[ind_case]+lambda_2[ind_case] - sqrt( pow(lambda_1[ind_case]-lambda_2[ind_case],2) + pow(2.0*lambda_5[ind_case],2) ) );
      if( temp > pert_unit_bound_val){chi2_2HDMScalar_pert_unit[ind_case] += pow( (temp - pert_unit_bound_val)/pert_unit_bound_unc, 2);}
      temp = 2.0*abs( lambda_3[ind_case]+lambda_4[ind_case] );
      if( temp > pert_unit_bound_val){chi2_2HDMScalar_pert_unit[ind_case] += pow( (temp - pert_unit_bound_val)/pert_unit_bound_unc, 2);}
      temp = abs( lambda_1[ind_case]+lambda_2[ind_case] + sqrt( pow(lambda_1[ind_case]-lambda_2[ind_case],2) + pow(2.0*lambda_4[ind_case],2) ) );
      if( temp > pert_unit_bound_val){chi2_2HDMScalar_pert_unit[ind_case] += pow( (temp - pert_unit_bound_val)/pert_unit_bound_unc, 2);}
      temp = abs( lambda_1[ind_case]+lambda_2[ind_case] - sqrt( pow(lambda_1[ind_case]-lambda_2[ind_case],2) + pow(2.0*lambda_4[ind_case],2) ) );
      if( temp > pert_unit_bound_val){chi2_2HDMScalar_pert_unit[ind_case] += pow( (temp - pert_unit_bound_val)/pert_unit_bound_unc, 2);}
      temp = abs( 3.0*(lambda_1[ind_case]+lambda_2[ind_case]) + sqrt( 9.0*pow(lambda_1[ind_case]-lambda_2[ind_case],2) + pow(4.0*lambda_3[ind_case]+2.0*lambda_4[ind_case],2) ) );
      if( temp > pert_unit_bound_val){chi2_2HDMScalar_pert_unit[ind_case] += pow( (temp - pert_unit_bound_val)/pert_unit_bound_unc, 2);}
      temp = abs( 3.0*(lambda_1[ind_case]+lambda_2[ind_case]) - sqrt( 9.0*pow(lambda_1[ind_case]-lambda_2[ind_case],2) + pow(4.0*lambda_3[ind_case]+2.0*lambda_4[ind_case],2) ) );
      if( temp > pert_unit_bound_val){chi2_2HDMScalar_pert_unit[ind_case] += pow( (temp - pert_unit_bound_val)/pert_unit_bound_unc, 2);}
      temp = 2.0*abs( lambda_3[ind_case]+2.0*lambda_4[ind_case]+3.0*abs(lambda_5[ind_case]) );
      if( temp > pert_unit_bound_val){chi2_2HDMScalar_pert_unit[ind_case] += pow( (temp - pert_unit_bound_val)/pert_unit_bound_unc, 2);}
      temp = 2.0*abs( lambda_3[ind_case]+2.0*lambda_4[ind_case]-3.0*abs(lambda_5[ind_case]) );
      if( temp > pert_unit_bound_val) {chi2_2HDMScalar_pert_unit[ind_case] += pow( (temp - pert_unit_bound_val)/pert_unit_bound_unc, 2);}
      temp = 2.0*abs( lambda_3[ind_case]-lambda_4[ind_case] );
      if( temp > pert_unit_bound_val) {chi2_2HDMScalar_pert_unit[ind_case] += pow( (temp - pert_unit_bound_val)/pert_unit_bound_unc, 2);}
      // -------------------------

      // Oblique T & S
      Oblique_T[ind_case] = ( pow(ROT[1][0],2)+pow(ROT[2][0],2) ) * F_oblique(mChH2,mh2);
      Oblique_T[ind_case] += ( pow(ROT[1][1],2)+pow(ROT[2][1],2) ) * F_oblique(mChH2,mH2);
      Oblique_T[ind_case] += ( pow(ROT[1][2],2)+pow(ROT[2][2],2) ) * F_oblique(mChH2,mA2);
      Oblique_T[ind_case] += -pow(ROT[0][2],2) * F_oblique(mh2,mH2);
      Oblique_T[ind_case] += -pow(ROT[0][1],2) * F_oblique(mh2,mA2);
      Oblique_T[ind_case] += -pow(ROT[0][0],2) * F_oblique(mA2,mH2);
      Oblique_T[ind_case] += 3.0 * ( pow(ROT[0][0],2) - 1.0 ) * (F_oblique(Mz2,mh2) - F_oblique(Mw2,mh2));
      Oblique_T[ind_case] += 3.0 * pow(ROT[0][1],2) * (F_oblique(Mz2,mH2) - F_oblique(Mw2,mH2));
      Oblique_T[ind_case] += 3.0 * pow(ROT[0][2],2) * (F_oblique(Mz2,mA2) - F_oblique(Mw2,mA2));
      Oblique_T[ind_case] *= 1.0/16.0/M_PI/sin2theta_w/Mw2;
      Oblique_T[ind_case] +=  - EXP_val_DT;

      Oblique_S[ind_case] = log(mH2*mA2/mChH2/mChH2) + pow(2.0*sin2theta_w-1.0,2) * G_oblique(mChH2/Mz2, mChH2/Mz2);
      Oblique_S[ind_case] += pow(ROT[0][2],2) * G_oblique(mh2/Mz2, mH2/Mz2);
      Oblique_S[ind_case] += pow(ROT[0][1],2) * G_oblique(mh2/Mz2, mA2/Mz2);
      Oblique_S[ind_case] += pow(ROT[0][0],2) * G_oblique(mH2/Mz2, mA2/Mz2);
      Oblique_S[ind_case] += ( pow(ROT[0][0],2) - 1.0 ) * Ghat_oblique(mh2,Mz2);
      Oblique_S[ind_case] += pow(ROT[0][1],2) * Ghat_oblique(mH2,Mz2);
      Oblique_S[ind_case] += pow(ROT[0][2],2) * Ghat_oblique(mA2,Mz2);
      Oblique_S[ind_case] *= 1.0/24.0/M_PI;
      Oblique_S[ind_case] +=  - EXP_val_DS;

      All_DeltaOblique[0] = Oblique_S[ind_case];
      All_DeltaOblique[1] = Oblique_T[ind_case];
      chi2_Oblique[ind_case] = 0.0;
      for (int i = 0; i < 2; i++) {for (int j = 0; j < 2; j++){chi2_Oblique[ind_case] += All_DeltaOblique[i]*All_DeltaOblique[j]*InvSigma2[i][j];}}
      // -------------------------
    
      // Scalar masses
      chi2_ScalarMasses[ind_case] = 0.0;
      if ( m_ChH[ind_case] < scalar_mass_bound_min )
	{
	  chi2_ScalarMasses[ind_case] += pow( (scalar_mass_bound_min-m_ChH[ind_case])/scalar_mass_bound_min_unc, 2);
	}
      if ( m_ChH[ind_case] > scalar_mass_bound_max )
	{
	  chi2_ScalarMasses[ind_case] += pow( (m_ChH[ind_case]-scalar_mass_bound_max)/scalar_mass_bound_max_unc, 2);
	}
      
      if ( m_H[ind_case] < scalar_mass_bound_min )
	{
	  chi2_ScalarMasses[ind_case] += pow( (scalar_mass_bound_min-m_H[ind_case])/scalar_mass_bound_min_unc, 2);
	}
      if ( m_H[ind_case] > scalar_mass_bound_max )
	{
	  chi2_ScalarMasses[ind_case] += pow( (m_H[ind_case]-scalar_mass_bound_max)/scalar_mass_bound_max_unc, 2);
	}
      
      if ( m_A[ind_case] < scalar_mass_bound_min )
	{
	  chi2_ScalarMasses[ind_case] += pow( (scalar_mass_bound_min-m_A[ind_case])/scalar_mass_bound_min_unc, 2);
	}
      if ( m_A[ind_case] > scalar_mass_bound_max )
	{
	  chi2_ScalarMasses[ind_case] += pow( (m_A[ind_case]-scalar_mass_bound_max)/scalar_mass_bound_max_unc, 2);
	}
      // --------------------------------------------------

      //      arg_n_le[ind_case]=-M_PI/2.0;
      //      arg_n_le[ind_case]=M_PI/2.0;
      //      arg_n_le[ind_case]=M_PI;
      //      arg_n_le[ind_case]=0.0;

      temp = 1.0/tb;
      re_n_qu = temp*m_qu; im_n_qu = 0.0;
      re_n_qc = temp*m_qc; im_n_qc = 0.0;
      re_n_qt = temp*m_qt; im_n_qt = 0.0;
      temp = 1.0/tb;
      re_n_qd = temp*m_qd; im_n_qd = 0.0; 
      re_n_qs = temp*m_qs; im_n_qs = 0.0;
      re_n_qb = temp*m_qb; im_n_qb = 0.0;

      re_n_le = a_nle[ind_case]; im_n_le = b_nle[ind_case];
      re_n_lm = a_nlm[ind_case]; im_n_lm = b_nlm[ind_case];
      re_n_lt = a_nlt[ind_case]; im_n_lt = b_nlt[ind_case];

      // test
      //      re_n_le=m_le;im_n_le=0.0;
      //      re_n_lm=m_lm;im_n_lm=0.0;
      //      re_n_lt=m_lt;im_n_lt=0.0;
      // -------------------------
      // Fermion scalar-pseudoscalar couplings
      // h
      a_h_qu = (ROT[0][0]*Masses_Up[0] + ROT[1][0]*re_n_qu + ROT[2][0]*im_n_qu) / VEV; b_h_qu = (ROT[1][0]*im_n_qu - ROT[2][0]*re_n_qu) / VEV;
      a_h_qc = (ROT[0][0]*Masses_Up[1] + ROT[1][0]*re_n_qc + ROT[2][0]*im_n_qc) / VEV; b_h_qc = (ROT[1][0]*im_n_qc - ROT[2][0]*re_n_qc) / VEV;
      a_h_qt = (ROT[0][0]*Masses_Up[2] + ROT[1][0]*re_n_qt + ROT[2][0]*im_n_qt) / VEV; b_h_qt = (ROT[1][0]*im_n_qt - ROT[2][0]*re_n_qt) / VEV;
      a_h_qd = (ROT[0][0]*Masses_Down[0] + ROT[1][0]*re_n_qd - ROT[2][0]*im_n_qd) / VEV; b_h_qd = (ROT[1][0]*im_n_qd + ROT[2][0]*re_n_qd) / VEV;
      a_h_qs = (ROT[0][0]*Masses_Down[1] + ROT[1][0]*re_n_qs - ROT[2][0]*im_n_qs) / VEV; b_h_qs = (ROT[1][0]*im_n_qs + ROT[2][0]*re_n_qs) / VEV;
      a_h_qb = (ROT[0][0]*Masses_Down[2] + ROT[1][0]*re_n_qb - ROT[2][0]*im_n_qb) / VEV; b_h_qb = (ROT[1][0]*im_n_qb + ROT[2][0]*re_n_qb) / VEV;
      a_h_le = (ROT[0][0]*m_le + ROT[1][0]*re_n_le - ROT[2][0]*im_n_le) / VEV; b_h_le = (ROT[1][0]*im_n_le + ROT[2][0]*re_n_le) / VEV;
      a_h_lm = (ROT[0][0]*m_lm + ROT[1][0]*re_n_lm - ROT[2][0]*im_n_lm) / VEV; b_h_lm = (ROT[1][0]*im_n_lm + ROT[2][0]*re_n_lm) / VEV;
      a_h_lt = (ROT[0][0]*m_lt + ROT[1][0]*re_n_lt - ROT[2][0]*im_n_lt) / VEV; b_h_lt = (ROT[1][0]*im_n_lt + ROT[2][0]*re_n_lt) / VEV;
      // H
      a_H_qu = (ROT[0][1]*Masses_Up[0] + ROT[1][1]*re_n_qu + ROT[2][1]*im_n_qu) / VEV; b_H_qu = (ROT[1][1]*im_n_qu - ROT[2][1]*re_n_qu) / VEV;
      a_H_qc = (ROT[0][1]*Masses_Up[1] + ROT[1][1]*re_n_qc + ROT[2][1]*im_n_qc) / VEV; b_H_qc = (ROT[1][1]*im_n_qc - ROT[2][1]*re_n_qc) / VEV;
      a_H_qt = (ROT[0][1]*Masses_Up[2] + ROT[1][1]*re_n_qt + ROT[2][1]*im_n_qt) / VEV; b_H_qt = (ROT[1][1]*im_n_qt - ROT[2][1]*re_n_qt) / VEV;
      a_H_qd = (ROT[0][1]*Masses_Down[0] + ROT[1][1]*re_n_qd - ROT[2][1]*im_n_qd) / VEV; b_H_qd = (ROT[1][1]*im_n_qd + ROT[2][1]*re_n_qd) / VEV;
      a_H_qs = (ROT[0][1]*Masses_Down[1] + ROT[1][1]*re_n_qs - ROT[2][1]*im_n_qs) / VEV; b_H_qs = (ROT[1][1]*im_n_qs + ROT[2][1]*re_n_qs) / VEV;
      a_H_qb = (ROT[0][1]*Masses_Down[2] + ROT[1][1]*re_n_qb - ROT[2][1]*im_n_qb) / VEV; b_H_qb = (ROT[1][1]*im_n_qb + ROT[2][1]*re_n_qb) / VEV;
      a_H_le = (ROT[0][1]*m_le + ROT[1][1]*re_n_le - ROT[2][1]*im_n_le) / VEV; b_H_le = (ROT[1][1]*im_n_le + ROT[2][1]*re_n_le) / VEV;
      a_H_lm = (ROT[0][1]*m_lm + ROT[1][1]*re_n_lm - ROT[2][1]*im_n_lm) / VEV; b_H_lm = (ROT[1][1]*im_n_lm + ROT[2][1]*re_n_lm) / VEV;
      a_H_lt = (ROT[0][1]*m_lt + ROT[1][1]*re_n_lt - ROT[2][1]*im_n_lt) / VEV; b_H_lt = (ROT[1][1]*im_n_lt + ROT[2][1]*re_n_lt) / VEV;
      // A
      a_A_qu = (ROT[0][2]*Masses_Up[0] + ROT[1][2]*re_n_qu + ROT[2][2]*im_n_qu) / VEV; b_A_qu = (ROT[1][2]*im_n_qu - ROT[2][2]*re_n_qu) / VEV;
      a_A_qc = (ROT[0][2]*Masses_Up[1] + ROT[1][2]*re_n_qc + ROT[2][2]*im_n_qc) / VEV; b_A_qc = (ROT[1][2]*im_n_qc - ROT[2][2]*re_n_qc) / VEV;
      a_A_qt = (ROT[0][2]*Masses_Up[2] + ROT[1][2]*re_n_qt + ROT[2][2]*im_n_qt) / VEV; b_A_qt = (ROT[1][2]*im_n_qt - ROT[2][2]*re_n_qt) / VEV;
      a_A_qd = (ROT[0][2]*Masses_Down[0] + ROT[1][2]*re_n_qd - ROT[2][2]*im_n_qd) / VEV; b_A_qd = (ROT[1][2]*im_n_qd + ROT[2][2]*re_n_qd) / VEV;
      a_A_qs = (ROT[0][2]*Masses_Down[1] + ROT[1][2]*re_n_qs - ROT[2][2]*im_n_qs) / VEV; b_A_qs = (ROT[1][2]*im_n_qs + ROT[2][2]*re_n_qs) / VEV;
      a_A_qb = (ROT[0][2]*Masses_Down[2] + ROT[1][2]*re_n_qb - ROT[2][2]*im_n_qb) / VEV; b_A_qb = (ROT[1][2]*im_n_qb + ROT[2][2]*re_n_qb) / VEV;
      a_A_le = (ROT[0][2]*m_le + ROT[1][2]*re_n_le - ROT[2][2]*im_n_le) / VEV; b_A_le = (ROT[1][2]*im_n_le + ROT[2][2]*re_n_le) / VEV;
      a_A_lm = (ROT[0][2]*m_lm + ROT[1][2]*re_n_lm - ROT[2][2]*im_n_lm) / VEV; b_A_lm = (ROT[1][2]*im_n_lm + ROT[2][2]*re_n_lm) / VEV;
      a_A_lt = (ROT[0][2]*m_lt + ROT[1][2]*re_n_lt - ROT[2][2]*im_n_lt) / VEV; b_A_lt = (ROT[1][2]*im_n_lt + ROT[2][2]*re_n_lt) / VEV;

      // -------------------------
      // Vector boson couplings 
      factor_h_VV = ROT[0][0];
      // ------------------------- 
      // H+H-h coupling

      hChCh = ROT[0][0] * ( pow(cb*sb,2) * (lambda_1[ind_case]+lambda_2[ind_case]-2.0*(lambda_3[ind_case]+lambda_4[ind_case]+lambda_5[ind_case])) + lambda_3[ind_case]);
      hChCh += - ROT[1][0] * cb*sb * ( lambda_1[ind_case] * sb*sb - lambda_2[ind_case] * cb*sb + (cb*cb-sb*sb) * (lambda_3[ind_case]+lambda_4[ind_case]+lambda_5[ind_case]));
//      hChCh += ROT[2][0] * cb*sb * s2t * lambda_5[ind_case];
      hChCh *= VEV2 / pow(m_ChH[ind_case],2);

      //      hChCh = 0.0;
      // ------------------------- 
      // Decay widths
      G_h_WW = G_h_SM * BR_h_WW_SM * pow(factor_h_VV,2);
      G_h_ZZ = G_h_SM * BR_h_ZZ_SM * pow(factor_h_VV,2);
      // ------------------------- 
      G_h_qs = ( (1.0-xh_qs) * pow(abs(a_h_qs),2) + pow(abs(b_h_qs),2) ) / SM_factor_G_h_qs * G_h_SM * BR_h_qs_SM;
      G_h_qb = ( (1.0-xh_qb) * pow(abs(a_h_qb),2) + pow(abs(b_h_qb),2) ) / SM_factor_G_h_qb * G_h_SM * BR_h_qb_SM;
      G_h_qc = ( (1.0-xh_qc) * pow(abs(a_h_qc),2) + pow(abs(b_h_qc),2) ) / SM_factor_G_h_qc * G_h_SM * BR_h_qc_SM;

      G_h_lt = ( (1.0-xh_lt) * pow(abs(a_h_lt),2) + pow(abs(b_h_lt),2) ) / SM_factor_G_h_lt * G_h_SM * BR_h_lt_SM;
      G_h_lm = ( (1.0-xh_lm) * pow(abs(a_h_lm),2) + pow(abs(b_h_lm),2) ) / SM_factor_G_h_lm * G_h_SM * BR_h_lm_SM;

      G_h_qu = 3.0 * C_hff * sqrt(1.0-xh_qu) * ( (1.0-xh_qu) * pow(abs(a_h_qu),2) + pow(abs(b_h_qu),2) );
      G_h_qd = 3.0 * C_hff * sqrt(1.0-xh_qd) * ( (1.0-xh_qd) * pow(abs(a_h_qd),2) + pow(abs(b_h_qd),2) );
      G_h_le = C_hff * sqrt(1.0-xh_le) * ( (1.0-xh_le) * pow(abs(a_h_le),2) + pow(abs(b_h_le),2) );
      // -------------------------
      // h->gamma+gamma 
      // scalar
      aux_c = 4.0/3.0 * a_h_qu * AF_qu;
      aux_c += 4.0/3.0 * a_h_qc * AF_qc;
      aux_c += 4.0/3.0 * a_h_qt * AF_qt;
      aux_c += 1.0 / 3.0 * a_h_qd * AF_qd;
      aux_c += 1.0 / 3.0 * a_h_qs * AF_qs;
      aux_c += 1.0 / 3.0 * a_h_qb * AF_qb;
      aux_c += a_h_le * AF_le;
      aux_c += a_h_lm * AF_lm;
      aux_c += a_h_lt * AF_lt;
      aux_c += factor_h_VV * AV_W;
      aux_c += hChCh * AS(pow(2.0*m_ChH[ind_case]/m_h,2));
      factor_G_h_gg = pow(abs(aux_c),2);
      // pseudoscalar 
      aux_c = 4.0/3.0 * b_h_qu * AFhat_qu;
      aux_c += 4.0/3.0 * b_h_qc * AFhat_qc;
      aux_c += 4.0/3.0 * b_h_qt * AFhat_qt;
      aux_c += 1.0 / 3.0 * b_h_qd * AFhat_qd;
      aux_c += 1.0 / 3.0 * b_h_qs * AFhat_qs;
      aux_c += 1.0 / 3.0 * b_h_qb * AFhat_qb;
      aux_c += b_h_le * AFhat_le;
      aux_c += b_h_lm * AFhat_lm;
      aux_c += b_h_lt * AFhat_lt;
      factor_G_h_gg += pow(abs(aux_c),2);
      factor_G_h_gg *= 1.0 / SM_factor_G_h_gg;
      // width
      G_h_gg = factor_G_h_gg * G_h_SM * BR_h_gg_SM;
      // -------------------------
      // h->gluon+gluon
      aux_c = a_h_qu * AF_qu;
      aux_c += a_h_qc * AF_qc;
      aux_c += a_h_qt * AF_qt;
      aux_c += a_h_qd * AF_qd;
      aux_c += a_h_qs * AF_qs;
      aux_c += a_h_qb * AF_qb;
      factor_G_h_GG = pow(abs(aux_c),2);
      aux_c = b_h_qu * AFhat_qu;
      aux_c += b_h_qc * AFhat_qc;
      aux_c += b_h_qt * AFhat_qt;
      aux_c += b_h_qd * AFhat_qd;
      aux_c += b_h_qs * AFhat_qs;
      aux_c += b_h_qb * AFhat_qb;
      factor_G_h_GG += pow(abs(aux_c),2);
      factor_G_h_GG *= 1.0 / SM_factor_G_h_GG;
      // width
      G_h_GG = factor_G_h_GG * G_h_SM * BR_h_GG_SM;
      // -------------------------
      // total width
      G_h[ind_case] = G_h_WW + G_h_ZZ + G_h_qu + G_h_qc + G_h_qd + G_h_qs + G_h_qb + G_h_le + G_h_lm + G_h_lt + G_h_GG + G_h_gg;
      // BRs
      BR_h_qd = G_h_qd / G_h[ind_case];
      BR_h_qs = G_h_qs / G_h[ind_case];
      BR_h_qb = G_h_qb / G_h[ind_case];
      BR_h_qu = G_h_qu / G_h[ind_case];
      BR_h_qc = G_h_qc / G_h[ind_case];
      BR_h_le = G_h_le / G_h[ind_case];
      BR_h_lm = G_h_lm / G_h[ind_case];
      BR_h_lt = G_h_lt / G_h[ind_case];
      BR_h_GG = G_h_GG / G_h[ind_case];
      BR_h_WW = G_h_WW / G_h[ind_case];
      BR_h_ZZ = G_h_ZZ / G_h[ind_case];
      BR_h_gg = G_h_gg / G_h[ind_case];
      G_h[ind_case] *= 1000.0; // Width in MeV
      // -------------------------

      // production K-factors
      K_prod_ggF = factor_G_h_GG;
      K_prod_VBF = pow(factor_h_VV,2);
      K_prod_WH = pow(factor_h_VV,2);
      K_prod_ZH = pow(factor_h_VV,2);
      K_prod_ttH = pow(VEV/m_qt,2)*( pow(abs(a_h_qt),2) + pow(abs(b_h_qt),2) );
      HiggsSignals_Run1_production[0] = K_prod_ggF;
      HiggsSignals_Run1_production[1] = K_prod_VBF;
      HiggsSignals_Run1_production[2] = K_prod_WH;
      HiggsSignals_Run1_production[3] = K_prod_ZH;
      HiggsSignals_Run1_production[4] = K_prod_ttH;

      // decay K-factors
      K_decay_gg = BR_h_gg / BR_h_gg_SM;
      K_decay_ZZ = BR_h_ZZ / BR_h_ZZ_SM;
      K_decay_WW = BR_h_WW / BR_h_WW_SM;
      K_decay_lt = BR_h_lt / BR_h_lt_SM;
      K_decay_qb = BR_h_qb / BR_h_qb_SM;
      HiggsSignals_Run1_decay[0] = K_decay_gg;
      HiggsSignals_Run1_decay[1] = K_decay_ZZ;
      HiggsSignals_Run1_decay[2] = K_decay_WW;
      HiggsSignals_Run1_decay[3] = K_decay_lt;
      HiggsSignals_Run1_decay[4] = K_decay_qb;

      //      K_ggF[ind_case] = K_prod_ggF;
      //      K_VV[ind_case] = K_prod_VBF;
      //      K_gg[ind_case] = K_decay_gg;
      //      K_bb[ind_case] = K_decay_qb;
      // -------------------------
      // Higgs signals
      for (int i_decay=0; i_decay<5; i_decay++)
	{
	  for (int i_prod=0; i_prod<5; i_prod++)
	    {
	      HiggsSignals_Run1[i_decay][i_prod] = HiggsSignals_Run1_decay[i_decay]*HiggsSignals_Run1_production[i_prod];
	    }
	}
      chi2_Higgs[ind_case] = 0.0;
      for(int i_decay=0; i_decay<5; i_decay++)
	{
	  for(int i_prod=0; i_prod<5; i_prod++)
	    {
	      if ( HiggsSignals_Run1[i_decay][i_prod] > HiggsSignals_EXP_VAL[i_decay][i_prod] )
		{
		  chi2_Higgs[ind_case] += pow( (HiggsSignals_Run1[i_decay][i_prod] - HiggsSignals_EXP_VAL[i_decay][i_prod]) / HiggsSignals_EXP_UNC_sup[i_decay][i_prod], 2);
		}
	      else
		{
		  chi2_Higgs[ind_case] += pow( (HiggsSignals_EXP_VAL[i_decay][i_prod] - HiggsSignals_Run1[i_decay][i_prod]) / HiggsSignals_EXP_UNC_inf[i_decay][i_prod], 2);
		}
	    }
	}
      // -------------------------
      // Total width
      if ( 0.001*G_h[ind_case] > G_h_bound_VAL )
	{
	  chi2_Higgs[ind_case] += pow( (0.001*G_h[ind_case] - G_h_bound_VAL) / G_h_bound_UNC,2);
	}

      // mu+mu- bound
      if ( BR_h_lm > BR_h_mm_bound_VAL * BR_h_lm_SM )
	{
	  chi2_Higgs[ind_case] += pow( (BR_h_lm / BR_h_lm_SM - BR_h_mm_bound_VAL) / BR_h_mm_bound_UNC,2);
	}

       // e+e- bound, absolute bound as muons
      if ( BR_h_le > BR_h_mm_bound_VAL * BR_h_lm_SM )
	{
	  chi2_Higgs[ind_case] += pow( (BR_h_le / BR_h_lm_SM - BR_h_mm_bound_VAL) / BR_h_mm_bound_UNC,2);
	}

      // -------------------------
      // Tree level decays H+/-
      chi2_tree_Charged[ind_case] = 0.0;

      Delta_K_lt.real() = re_n_lt / m_lt; Delta_K_lt.imag() = -im_n_lt / m_lt;
      Delta_Pi_lt = Delta_K_lt;
      Delta_K_lm.real() = re_n_lm / m_lm; Delta_K_lm.imag() = -im_n_lm / m_lm;
      Delta_Pi_lm = Delta_K_lm;
      Delta_K_le.real() = re_n_le / m_le; Delta_K_le.imag() = -im_n_le / m_le;
      Delta_Pi_le = Delta_K_le;
      temp = pow(m_K/m_ChH[ind_case],2) * (re_n_qu + re_n_qs) / (m_qu + m_qs);
      Delta_K_lt *= temp; Delta_K_lm *= temp; Delta_K_le *= temp;
      temp = pow(m_Pi/m_ChH[ind_case],2) * (re_n_qu + re_n_qd) / (m_qu + m_qd);
      Delta_Pi_lt *= temp; Delta_Pi_lm *= temp; Delta_Pi_le *= temp;
      gSRR_lm_le.real() = -re_n_le*re_n_lm-im_n_le*im_n_lm; gSRR_lm_le.imag() = -re_n_le*im_n_lm+im_n_le*re_n_lm;
      gSRR_lm_le *= pow(1.0/m_ChH[ind_case],2);
      gSRR_lt_lm.real() = -re_n_lm*re_n_lt-im_n_lm*im_n_lt; gSRR_lt_lm.imag() = -re_n_lm*im_n_lt+im_n_lm*re_n_lt;
      gSRR_lt_lm *= pow(1.0/m_ChH[ind_case],2);
      gSRR_lt_le.real() = -re_n_le*re_n_lt-im_n_le*im_n_lt; gSRR_lt_le.imag() = -re_n_le*im_n_lt+im_n_le*re_n_lt;
      gSRR_lt_le *= pow(1.0/m_ChH[ind_case],2);
      // --
      temp = pow( abs(1.0-Delta_K_lt)/abs(1.0-Delta_K_lm),2);
      //      temp = 1.0;
      chi2_tree_Charged[ind_case] += pow( abs(temp - R_K_lt_lm_val) / R_K_lt_lm_unc , 2);
      temp = pow( abs(1.0-Delta_K_lm)/abs(1.0-Delta_K_le),2);
      //      temp = 1.0;
      chi2_tree_Charged[ind_case] += pow( abs(temp - R_K_lm_le_val) / R_K_lm_le_unc , 2);
      temp = pow( abs(1.0-Delta_Pi_lt)/abs(1.0-Delta_Pi_lm),2);
      //      temp = 1.0;
      chi2_tree_Charged[ind_case] += pow( abs(temp - R_Pi_lt_lm_val) / R_Pi_lt_lm_unc , 2);
      temp = pow( abs(1.0-Delta_Pi_lm)/abs(1.0-Delta_Pi_le),2);
      //      temp = 1.0;
      chi2_tree_Charged[ind_case] += pow( abs(temp - R_Pi_lm_le_val) / R_Pi_lm_le_unc , 2);
      // --
      temp = (1.0 + 0.25 * pow(abs(gSRR_lt_le),2))*(1.0 + 2.0*real(gSRR_lt_le)*m_le/m_lt*PhSp_g_lt_le/PhSp_f_lt_le/(1.0 + 0.25 * pow(abs(gSRR_lt_le),2)));
      temp = 1.0 / temp;
      temp *= (1.0 + 0.25 * pow(abs(gSRR_lt_lm),2))*(1.0 + 2.0*real(gSRR_lt_lm)*m_lm/m_lt*PhSp_g_lt_lm/PhSp_f_lt_lm/(1.0 + 0.25 * pow(abs(gSRR_lt_lm),2)));
      //      temp = 1.0;
      chi2_tree_Charged[ind_case] += pow( abs(temp - R_lt_lm_le_val) / R_lt_lm_le_unc , 2);
      temp = (1.0 + 0.25 * pow(abs(gSRR_lm_le),2))*(1.0 + 2.0*real(gSRR_lm_le)*m_le/m_lm*PhSp_g_lm_le/PhSp_f_lm_le/(1.0 + 0.25 * pow(abs(gSRR_lm_le),2)));
      temp = 1.0 / temp;
      temp = (1.0 + 0.25 * pow(abs(gSRR_lt_le),2))*(1.0 + 2.0*real(gSRR_lt_le)*m_le/m_lt*PhSp_g_lt_le/PhSp_f_lt_le/(1.0 + 0.25 * pow(abs(gSRR_lt_le),2)));
      //      temp = 1.0;
      chi2_tree_Charged[ind_case] += pow( abs(temp - R_le_lt_lm_val) / R_le_lt_lm_unc , 2);
      // --
      temp = abs(abs(gSRR_lm_le)-gSRR_lm_le_val);
      //      temp = 0.0;
      if( temp > gSRR_lm_le_unc ){ chi2_tree_Charged[ind_case] += pow( (temp - gSRR_lm_le_unc)/gSRR_lm_le_unc, 2);}
      temp = abs(abs(gSRR_lt_lm)-gSRR_lt_lm_val);
      //      temp = 0.0;
      if( temp > gSRR_lt_lm_unc ){ chi2_tree_Charged[ind_case] += pow( (temp - gSRR_lt_lm_unc)/gSRR_lt_lm_unc, 2);}
      temp = abs(abs(gSRR_lt_le)-gSRR_lt_le_val);
      //      temp = 0.0;
      if( temp > gSRR_lt_le_unc ){ chi2_tree_Charged[ind_case] += pow( (temp - gSRR_lt_le_unc)/gSRR_lt_le_unc, 2);}
      // -------------------------


      // -------------------------
      // Dipoles
      anom_le[ind_case]=0.0;
      anom_lm[ind_case]=0.0;
      anom_lt[ind_case]=0.0;
      edm_le[ind_case]=0.0;
      edm_lm[ind_case]=0.0;
      edm_lt[ind_case]=0.0;
      // 1 loop
      // h
      anom_le[ind_case]+=pow(a_h_le,2)*(2.0*Dipole_I2(pow(m_le,2)/mh2)-Dipole_I3(pow(m_le,2)/mh2))-pow(b_h_le,2)*Dipole_I3(pow(m_le,2)/mh2);
      anom_lm[ind_case]+=pow(a_h_lm,2)*(2.0*Dipole_I2(pow(m_lm,2)/mh2)-Dipole_I3(pow(m_lm,2)/mh2))-pow(b_h_lm,2)*Dipole_I3(pow(m_lm,2)/mh2);
      anom_lt[ind_case]+=pow(a_h_lt,2)*(2.0*Dipole_I2(pow(m_lt,2)/mh2)-Dipole_I3(pow(m_lt,2)/mh2))-pow(b_h_lt,2)*Dipole_I3(pow(m_lt,2)/mh2);
      edm_le[ind_case]+=a_h_le*b_h_le/m_le*Dipole_I2(pow(m_le,2)/mh2);
      edm_lm[ind_case]+=a_h_lm*b_h_lm/m_lm*Dipole_I2(pow(m_lm,2)/mh2);
      edm_lt[ind_case]+=a_h_lt*b_h_lt/m_lt*Dipole_I2(pow(m_lt,2)/mh2);
      // H
      anom_le[ind_case]+=pow(a_H_le,2)*(2.0*Dipole_I2(pow(m_le,2)/mH2)-Dipole_I3(pow(m_le,2)/mH2))-pow(b_H_le,2)*Dipole_I3(pow(m_le,2)/mH2);
      anom_lm[ind_case]+=pow(a_H_lm,2)*(2.0*Dipole_I2(pow(m_lm,2)/mH2)-Dipole_I3(pow(m_lm,2)/mH2))-pow(b_H_lm,2)*Dipole_I3(pow(m_lm,2)/mH2);
      anom_lt[ind_case]+=pow(a_H_lt,2)*(2.0*Dipole_I2(pow(m_lt,2)/mH2)-Dipole_I3(pow(m_lt,2)/mH2))-pow(b_H_lt,2)*Dipole_I3(pow(m_lt,2)/mH2);
      edm_le[ind_case]+=a_H_le*b_H_le/m_le*Dipole_I2(pow(m_le,2)/mH2);
      edm_lm[ind_case]+=a_H_lm*b_H_lm/m_lm*Dipole_I2(pow(m_lm,2)/mH2);
      edm_lt[ind_case]+=a_H_lt*b_H_lt/m_lt*Dipole_I2(pow(m_lt,2)/mH2);
      // A
      anom_le[ind_case]+=pow(a_A_le,2)*(2.0*Dipole_I2(pow(m_le,2)/mA2)-Dipole_I3(pow(m_le,2)/mA2))-pow(b_A_le,2)*Dipole_I3(pow(m_le,2)/mA2);
      anom_lm[ind_case]+=pow(a_A_lm,2)*(2.0*Dipole_I2(pow(m_lm,2)/mA2)-Dipole_I3(pow(m_lm,2)/mA2))-pow(b_A_lm,2)*Dipole_I3(pow(m_lm,2)/mA2);
      anom_lt[ind_case]+=pow(a_A_lt,2)*(2.0*Dipole_I2(pow(m_lt,2)/mA2)-Dipole_I3(pow(m_lt,2)/mA2))-pow(b_A_lt,2)*Dipole_I3(pow(m_lt,2)/mA2);
      edm_le[ind_case]+=a_A_le*b_A_le/m_le*Dipole_I2(pow(m_le,2)/mA2);
      edm_lm[ind_case]+=a_A_lm*b_A_lm/m_lm*Dipole_I2(pow(m_lm,2)/mH2);
      edm_lt[ind_case]+=a_A_lt*b_A_lt/m_lt*Dipole_I2(pow(m_lt,2)/mH2);
      // H+-
      a_le = re_n_le / VEV * sqrt(2.0); b_le = im_n_le / VEV * sqrt(2.0);
      a_lm = re_n_lm / VEV * sqrt(2.0); b_lm = im_n_lm / VEV * sqrt(2.0);
      a_lt = re_n_lt / VEV * sqrt(2.0); b_lt = im_n_lt / VEV * sqrt(2.0);
      anom_le[ind_case]+=-(pow(a_le,2)+pow(b_le,2))*Dipole_J(pow(m_le,2)/mChH2);
      anom_lm[ind_case]+=-(pow(a_lm,2)+pow(b_lm,2))*Dipole_J(pow(m_lm,2)/mChH2);
      anom_lt[ind_case]+=-(pow(a_lt,2)+pow(b_lt,2))*Dipole_J(pow(m_lt,2)/mChH2);

      anom_le[ind_case]*=1.0/8.0/pow(M_PI,2);
      anom_lm[ind_case]*=1.0/8.0/pow(M_PI,2);
      anom_lt[ind_case]*=1.0/8.0/pow(M_PI,2);
      edm_le[ind_case]*=1.0/8.0/pow(M_PI,2);
      edm_lm[ind_case]*=1.0/8.0/pow(M_PI,2);
      edm_lt[ind_case]*=1.0/8.0/pow(M_PI,2);
      // 2 loop ( t & b Barr-Zee)
      // e
      anom_le[ind_case]+= BarrZee_factor * ( - a_h_le * a_h_qt * f_BarrZee( pow(Masses_Up[2],2)/mh2 ) + b_h_le * b_h_qt * g_BarrZee( pow(Masses_Up[2],2)/mh2 ) ) * m_le / Masses_Up[2];
      anom_le[ind_case]+= BarrZee_factor * 0.25 * ( - a_h_le * a_h_qb * f_BarrZee( pow(Masses_Down[2],2)/mh2 ) + b_h_le * b_h_qb * g_BarrZee( pow(Masses_Down[2],2)/mh2 ) ) * m_le / Masses_Down[2]; 
      anom_le[ind_case]+= BarrZee_factor * ( - a_H_le * a_H_qt * f_BarrZee( pow(Masses_Up[2],2)/mH2 ) + b_H_le * b_H_qt * g_BarrZee( pow(Masses_Up[2],2)/mH2 ) ) * m_le / Masses_Up[2]; 
      anom_le[ind_case]+= BarrZee_factor * 0.25 * ( - a_H_le * a_H_qb * f_BarrZee( pow(Masses_Down[2],2)/mH2 ) + b_H_le * b_H_qb * g_BarrZee( pow(Masses_Down[2],2)/mH2 ) ) * m_le / Masses_Down[2];
      anom_le[ind_case]+= BarrZee_factor * ( - a_A_le * a_A_qt * f_BarrZee( pow(Masses_Up[2],2)/mA2 ) + b_A_le * b_A_qt * g_BarrZee( pow(Masses_Up[2],2)/mA2 ) ) * m_le / Masses_Up[2]; 
      anom_le[ind_case]+= BarrZee_factor * 0.25 * ( - a_A_le * a_A_qb * f_BarrZee( pow(Masses_Down[2],2)/mA2 ) + b_A_le * b_A_qb * g_BarrZee( pow(Masses_Down[2],2)/mA2 ) ) * m_le / Masses_Down[2];
      // m
      anom_lm[ind_case]+= BarrZee_factor * ( - a_h_lm * a_h_qt * f_BarrZee( pow(Masses_Up[2],2)/mh2 ) + b_h_lm * b_h_qt * g_BarrZee( pow(Masses_Up[2],2)/mh2 ) ) * m_lm / Masses_Up[2]; 
      anom_lm[ind_case]+= BarrZee_factor * 0.25 * ( - a_h_lm * a_h_qb * f_BarrZee( pow(Masses_Down[2],2)/mh2 ) + b_h_lm * b_h_qb * g_BarrZee( pow(Masses_Down[2],2)/mh2 ) ) * m_lm / Masses_Down[2];
      anom_lm[ind_case]+= BarrZee_factor * ( - a_H_lm * a_H_qt * f_BarrZee( pow(Masses_Up[2],2)/mH2 ) + b_H_lm * b_H_qt * g_BarrZee( pow(Masses_Up[2],2)/mH2 ) ) * m_lm / Masses_Up[2];
      anom_lm[ind_case]+= BarrZee_factor * 0.25 * ( - a_H_lm * a_H_qb * f_BarrZee( pow(Masses_Down[2],2)/mH2 ) + b_H_lm * b_H_qb * g_BarrZee( pow(Masses_Down[2],2)/mH2 ) ) * m_lm / Masses_Down[2];
      anom_lm[ind_case]+= BarrZee_factor * ( - a_A_lm * a_A_qt * f_BarrZee( pow(Masses_Up[2],2)/mA2 ) + b_A_lm * b_A_qt * g_BarrZee( pow(Masses_Up[2],2)/mA2 ) ) * m_lm / Masses_Up[2];
      anom_lm[ind_case]+= BarrZee_factor * 0.25 * ( - a_A_lm * a_A_qb * f_BarrZee( pow(Masses_Down[2],2)/mA2 ) + b_A_lm * b_A_qb * g_BarrZee( pow(Masses_Down[2],2)/mA2 ) ) * m_lm / Masses_Down[2];
      // t
      anom_lt[ind_case]+= BarrZee_factor * ( - a_h_lt * a_h_qt * f_BarrZee( pow(Masses_Up[2],2)/mh2 ) + b_h_lt * b_h_qt * g_BarrZee( pow(Masses_Up[2],2)/mh2 ) ) * m_lt / Masses_Up[2]; 
      anom_lt[ind_case]+= BarrZee_factor * 0.25 * ( - a_h_lt * a_h_qb * f_BarrZee( pow(Masses_Down[2],2)/mh2 ) + b_h_lt * b_h_qb * g_BarrZee( pow(Masses_Down[2],2)/mh2 ) ) * m_lt / Masses_Down[2];
      anom_lt[ind_case]+= BarrZee_factor * ( - a_H_lt * a_H_qt * f_BarrZee( pow(Masses_Up[2],2)/mH2 ) + b_H_lt * b_H_qt * g_BarrZee( pow(Masses_Up[2],2)/mH2 ) ) * m_lt / Masses_Up[2];
      anom_lt[ind_case]+= BarrZee_factor * 0.25 * ( - a_H_lt * a_H_qb * f_BarrZee( pow(Masses_Down[2],2)/mH2 ) + b_H_lt * b_H_qb * g_BarrZee( pow(Masses_Down[2],2)/mH2 ) ) * m_lt / Masses_Down[2];
      anom_lt[ind_case]+= BarrZee_factor * ( - a_A_lt * a_A_qt * f_BarrZee( pow(Masses_Up[2],2)/mA2 ) + b_A_lt * b_A_qt * g_BarrZee( pow(Masses_Up[2],2)/mA2 ) ) * m_lt / Masses_Up[2];
      anom_lt[ind_case]+= BarrZee_factor * 0.25 * ( - a_A_lt * a_A_qb * f_BarrZee( pow(Masses_Down[2],2)/mA2 ) + b_A_lt * b_A_qb * g_BarrZee( pow(Masses_Down[2],2)/mA2 ) ) * m_lt / Masses_Down[2];


      // final
      anom_le[ind_case]*=1.0e13;
      anom_lm[ind_case]*=1.0e09;
      anom_lt[ind_case]=log10(abs(anom_lt[ind_case]));
      edm_le[ind_case]*=197.327e13;// in 1.0e-29 e.cm
      edm_le[ind_case]=abs(edm_le[ind_case]);
      edm_lm[ind_case]*=197.327e-16;// in e.cm
      edm_lm[ind_case]=log10(abs(edm_lm[ind_case]));
      edm_lt[ind_case]*=197.327e-16;// in e.cm
      edm_lt[ind_case]=log10(abs(edm_lt[ind_case]));
      // -------------------------

      chi2_dipoles[ind_case] = 0.0;
      chi2_dipoles[ind_case] += pow((anom_le[ind_case]-dev_a_le_VAL)/dev_a_le_UNC,2);
      chi2_dipoles[ind_case] += pow((anom_lm[ind_case]-dev_a_lm_VAL)/dev_a_lm_UNC,2);
      if(edm_le[ind_case]>edm_le_VAL){chi2_dipoles[ind_case] += pow((edm_le[ind_case]-edm_le_VAL)/edm_le_UNC,2);}

      chi2_yukawa_pert[ind_case] = 0.0;
      temp = sqrt( pow(a_nle[ind_case],2) + pow(b_nle[ind_case],2) );
      if(temp>yukawa_pert_lep_VAL){chi2_yukawa_pert[ind_case] += pow((temp-yukawa_pert_lep_VAL)/yukawa_pert_UNC,2);}
      temp = sqrt( pow(a_nlm[ind_case],2) + pow(b_nlm[ind_case],2) );
      if(temp>yukawa_pert_lep_VAL){chi2_yukawa_pert[ind_case] += pow((temp-yukawa_pert_lep_VAL)/yukawa_pert_UNC,2);}
      temp = sqrt( pow(a_nlt[ind_case],2) + pow(b_nlt[ind_case],2) );
      if(temp>yukawa_pert_lep_VAL){chi2_yukawa_pert[ind_case] += pow((temp-yukawa_pert_lep_VAL)/yukawa_pert_UNC,2);}
      temp = sqrt( pow(re_n_qb,2) + pow(im_n_qb,2) );
      if(temp>yukawa_pert_VAL){chi2_yukawa_pert[ind_case] += pow((temp-yukawa_pert_VAL)/yukawa_pert_UNC,2);}
      temp = sqrt( pow(re_n_qt,2) + pow(im_n_qt,2) );
      if(temp>yukawa_pert_VAL){chi2_yukawa_pert[ind_case] += pow((temp-yukawa_pert_VAL)/yukawa_pert_UNC,2);}


      // --------------------------------------------------
      // Scalar widths


      // --------------------------------------------------
      // b->s+gamma
      {
	int is=1, ib=2;
	obs A0_uCh[3], A1_uCh[3], A2_uCh[3], A3_uCh[3];
	for(int k=0; k<3; k++)
	  {
	    A0_uCh[k] = A0_Scalar(pow(Masses_Up[k]/m_ChH[ind_case],2));
	    A1_uCh[k] = A1_Scalar(pow(Masses_Up[k]/m_ChH[ind_case],2));
	    A2_uCh[k] = A2_Scalar(pow(Masses_Up[k]/m_ChH[ind_case],2));
	    A3_uCh[k] = A3_Scalar(pow(Masses_Up[k]/m_ChH[ind_case],2));
	  }
	obs Nu[3], Nd[3];
	Nu[0] = re_n_qu / VEV; Nu[1] = re_n_qc / VEV; Nu[2] = re_n_qt / VEV;
        Nd[0] = re_n_qd / VEV; Nd[1] = re_n_qs / VEV; Nd[2] = re_n_qb / VEV;
	// C7
	DC7_mw = aux_c_0;
	for(int k=0; k<3; k++)
	  {
	    //            DC7_mw += VdagNu[is][k] * ( conj(VdagNu[ib][k])*A2_uCh[k] + Masses_Up[k]/Masses_Down[ib]*VNd[k][ib]*A3_uCh[k] ) / pow(m_ChH[ind_case],2);
	    DC7_mw += CKMdag[is][k] * Nu[k] * ( conj(CKMdag[ib][k]*Nu[k])*A2_uCh[k] + Masses_Up[k]/Masses_Down[ib]*CKM[k][ib]*Nd[ib]*A3_uCh[k] ) / pow(m_ChH[ind_case],2);
	  }
	DC7_mw *= 0.5 * VEV2 / CKM[2][ib] / conj(CKM[2][is]);
	// C8
	DC8_mw  = aux_c_0;
	for(int k=0; k<3; k++)
	  {
	    //	    DC8_mw += 2.0*VdagNu[is][k] * ( -conj(VdagNu[ib][k])*A0_uCh[k] + Masses_Up[k]/Masses_Down[ib]*VNd[k][ib]*A1_uCh[k] ) / pow(m_ChH[ind_case],2);
            DC8_mw += 2.0*CKMdag[is][k]*Nu[k] * ( -conj(CKMdag[ib][k]*Nu[k])*A0_uCh[k] + Masses_Up[k]/Masses_Down[ib]*CKM[k][ib]*Nd[ib]*A1_uCh[k] ) / pow(m_ChH[ind_case],2);
 	  }
	DC8_mw *= 0.5 * VEV2 / CKM[2][ib] / conj(CKM[2][is]);
	// C7
	DC7prime_mw = aux_c_0;
	for(int k=0; k<3; k++)
	  {
	    //            DC7prime_mw += conj(VNd[k][ib])*VNd[k][is]*A2_uCh[k] / pow(m_ChH[ind_case],2);
            DC7prime_mw += conj(CKM[k][ib]*Nd[ib])*CKM[k][is]*Nd[is]*A2_uCh[k] / pow(m_ChH[ind_case],2);
	  }
	DC7prime_mw *= 0.5 * VEV2 / CKM[2][ib] / conj(CKM[2][is]);
	// C8
	DC8prime_mw = aux_c_0;
	for(int k=0; k<3; k++)
	  {
	    //	    DC8prime_mw += -2.0*conj(VNd[k][ib])*VNd[k][is]*A0_uCh[k] / pow(m_ChH[ind_case],2);
            DC8prime_mw += -2.0*conj(CKM[k][ib]*Nd[ib])*CKM[k][is]*Nd[is]*A0_uCh[k] / pow(m_ChH[ind_case],2);
	  }
	DC8prime_mw *= 0.5 * VEV2 / CKM[2][ib] / conj(CKM[2][is]);
	DC7_mb = 0.636*DC7_mw - 0.373*DC8_mw;
	DC7prime_mb = 0.636*DC7prime_mw - 0.373*DC8prime_mw;
	BR_bsg[ind_case] = BR_bsg_SM + 2.47e-03 * ( pow(abs(DC7_mb),2) + pow(abs(DC7prime_mb),2) - 0.706 * real(DC7_mb));
	chi2_bsgamma[ind_case] = pow( (BR_bsg[ind_case]-BR_bsg_EXP_val)/BR_bsg_EXP_unc, 2);
	// test if SM+2HDM~-SM
	if(real(DC7_mb)>0.07){chi2_bsgamma[ind_case] += pow((real(DC7_mb)-0.07)/0.01,2);}
	BR_bsg[ind_case] *= 1.0e4;
      }
      // --------------------------------------------------

      chi2[ind_case] = 0.0;

      //      if (R11[ind_case]<R11_bound_val){chi2[ind_case] += pow(abs(R11_bound_val-R11[ind_case])/R11_bound_unc, 2);}

      // --------------------------------------------------
      /*    
	    chi2[ind_case] = 100000.0;
	    chi2[ind_case] += chi2_2HDMscalar; chi2[ind_case] += -30000.0;
	    chi2[ind_case] += chi2_scalarmasses; chi2[ind_case] += -30000.0;
	    chi2[ind_case] += chi2_2HDMoblique; chi2[ind_case] += -30000.0;
      */
      // --------------------------------------------------
      chi2[ind_case] += chi2_yukawa_pert[ind_case] + chi2_2HDMScalar_pert[ind_case] + chi2_2HDMScalar_pert_unit[ind_case] + chi2_ScalarMasses[ind_case] + chi2_Oblique[ind_case] + chi2_Higgs[ind_case] + chi2_dipoles[ind_case] + chi2_bsgamma[ind_case] + chi2_tree_Charged[ind_case];
      // --------------------------------------------------



    }// END chi2
    // --------------------------------------------------
    
    //  chi2[ind_case] = sqrt(chi2[ind_case]);
    /*  
	chi2_Smps[ind_case] = 1.0;
	dchi2_Smps[ind_case] = abs(chi2_Smps[ind_case] - chi2_Smps[not_ind_case]);
    */

  
  // Cutoff
  if(chi2[ind_case]>1.0e20*chi2_Lcut) {chi2[ind_case]=chi2_Lcut;}
  
  // Finally the probability
  prob[ind_case] = probab(chi2[ind_case]);

}
//--------------------------------------------------
// Compute observables & chi2 for the candidate point
void model_calculations_heat(int ind_case)
{
  model_calculations(ind_case);
  //  chi2_heat[ind_case] = 0.30 * chi2[ind_case] + 5.0 * chi2_dipoles[ind_case];
  chi2_heat[ind_case] = 0.20 * chi2[ind_case];
  prob_heat[ind_case] = probab(chi2_heat[ind_case]);
}
