//--------------------------------------------------
void model_prepare()
{
  //  aux_c_0.real() = 0.0; aux_c_0.imag() = 0.0;
  //  unit_i.real() = 0.0; unit_i.imag() = 1.0;
  /*
  cout << "I2(e)=" << Dipole_I2(pow(m_le,2)/mh2) << endl;
  cout << "I3(e)=" << Dipole_I3(pow(m_le,2)/mh2) << endl;
  cout << "J(e)=" << Dipole_J(pow(m_le,2)/mh2) << endl;
  cout << "I2(m)=" << Dipole_I2(pow(m_lm,2)/mh2) << endl;
  cout << "I3(m)=" << Dipole_I3(pow(m_lm,2)/mh2) << endl;
  cout << "J(m)=" << Dipole_J(pow(m_lm,2)/mh2) << endl;
  cout << "I2(t)=" << Dipole_I2(pow(m_lt,2)/mh2) << endl;
  cout << "I3(t)=" << Dipole_I3(pow(m_lt,2)/mh2) << endl;
  cout << "J(t)=" << Dipole_J(pow(m_lt,2)/mh2) << endl;
  */
  // --------------------------------------------------
  // --------------------------------------------------
  // CKM
  {
    obs d13, t12, t13, t23;
    obs c12, c13, c23, s12, s13, s23;
    obs_c exp_p_id13, exp_m_id13;
    t13 = 0.003746;
    t12 = asin(0.224745/cos(t13));
    t23 = 0.042;
    d13 = 65.81 / 180.0 * M_PI;
    c13 = cos(d13); s13 = sin(d13); exp_p_id13.real() = c13; exp_p_id13.imag() = s13; exp_m_id13.real() = c13; exp_m_id13.imag() = -s13;
    c12 = cos(t12); s12 = sin(t12);
    c13 = cos(t13); s13 = sin(t13);
    c23 = cos(t23); s23 = sin(t23);

    CKM[0][0] = c12 * c13;
    CKM[0][1] = c13 * s12;
    CKM[0][2] = s13 * exp_m_id13;
    CKM[1][0] = -c23 * s12 - c12 * s13 * s23 * exp_p_id13;
    CKM[1][1] = c12 * c23 - s12 * s13 * s23 * exp_p_id13;
    CKM[1][2] = c13 * s23;
    CKM[2][0] = -c12 * c23 * s13 * exp_p_id13 + s12 * s23;
    CKM[2][1] = -c23 * s12 * s13 * exp_p_id13 - c12 * s23;
    CKM[2][2] = c13 * c23;
    for (int i=0; i<3; i++)
      {
	for (int j=0; j<3; j++)
	  {
	    CKMdag[i][j] = conj(CKM[j][i]);
	  }
      }
  }
  // --------------------------------------------------
  // --------------------------------------------------
    
  // --------------------------------------------------
  // --------------------------------------------------
  // Higgs
  // -------------------------
  SM_factor_G_h_qc = (1.0-xh_qc) * pow(m_qc/VEV,2);
  SM_factor_G_h_qs = (1.0-xh_qs) * pow(m_qs/VEV,2);
  SM_factor_G_h_qb = (1.0-xh_qb) * pow(m_qb/VEV,2);
  SM_factor_G_h_lm = (1.0-xh_lm) * pow(m_lm/VEV,2);
  SM_factor_G_h_lt = (1.0-xh_lt) * pow(m_lt/VEV,2);
  // -------------------------
  // Loop functions for h->gg,GG
  // Including v/m prefactor for fermions
  AF_qu = VEV/m_qu*AF(xh_qu); AFhat_qu = VEV/m_qu*AFhat(xh_qu);
  AF_qc = VEV/m_qc*AF(xh_qc); AFhat_qc = VEV/m_qc*AFhat(xh_qc);
  AF_qt = VEV/m_qt*AF(xh_qt); AFhat_qt = VEV/m_qt*AFhat(xh_qt);
  AF_qd = VEV/m_qd*AF(xh_qd); AFhat_qd = VEV/m_qd*AFhat(xh_qd);
  AF_qs = VEV/m_qs*AF(xh_qs); AFhat_qs = VEV/m_qs*AFhat(xh_qs);
  AF_qb = VEV/m_qb*AF(xh_qb); AFhat_qb = VEV/m_qb*AFhat(xh_qb);
  AF_le = VEV/m_le*AF(xh_le); AFhat_le = VEV/m_le*AFhat(xh_le);
  AF_lm = VEV/m_lm*AF(xh_lm); AFhat_lm = VEV/m_lm*AFhat(xh_lm);
  AF_lt = VEV/m_lt*AF(xh_lt); AFhat_lt = VEV/m_lt*AFhat(xh_lt);
  AV_W = AV(4.0*Mw2/mh2);
  // -------------------------
  // h->gamma+gamma
  aux_c = 4.0/3.0 * m_qu/VEV * AF_qu;
  aux_c += 4.0/3.0 * m_qc/VEV * AF_qc;
  aux_c += 4.0/3.0 * m_qt/VEV * AF_qt;
  aux_c += 1.0 / 3.0 * m_qd/VEV * AF_qd;
  aux_c += 1.0 / 3.0 * m_qs/VEV * AF_qs;
  aux_c += 1.0 / 3.0 * m_qb/VEV * AF_qb;
  aux_c += m_le/VEV * AF_le;
  aux_c += m_lm/VEV * AF_lm;
  aux_c += m_lt/VEV * AF_lt;
  aux_c += AV_W;
  SM_factor_G_h_gg = pow(abs(aux_c),2);
  // -------------------------
  // h->gluon+gluon
  aux_c = m_qu/VEV * AF_qu;
  aux_c += m_qc/VEV * AF_qc;
  aux_c += m_qt/VEV * AF_qt;
  aux_c += m_qd/VEV * AF_qd;
  aux_c += m_qs/VEV * AF_qs;
  aux_c += m_qb/VEV * AF_qb;
  SM_factor_G_h_GG = pow(abs(aux_c),2);
  // --------------

  // --------------------------------------------------
  PhSp_f_lt_lm = PhaseSpace_f(pow(m_lm/m_lt,2));
  PhSp_g_lt_lm = PhaseSpace_g(pow(m_lm/m_lt,2));
  PhSp_f_lt_le = PhaseSpace_f(pow(m_le/m_lt,2));
  PhSp_g_lt_le = PhaseSpace_g(pow(m_le/m_lt,2));
  PhSp_f_lm_le = PhaseSpace_f(pow(m_le/m_lm,2));
  PhSp_g_lm_le = PhaseSpace_g(pow(m_le/m_lm,2));
  cout << "PhSp_f_lt_lm = " << PhSp_f_lt_lm << endl;
  cout << "PhSp_g_lt_lm = " << PhSp_g_lt_lm << endl;
  cout << "PhSp_f_lt_le = " << PhSp_f_lt_le << endl;
  cout << "PhSp_g_lt_le = " << PhSp_g_lt_le << endl;
  cout << "PhSp_f_lm_le = " << PhSp_f_lm_le << endl;
  cout << "PhSp_g_lm_le = " << PhSp_g_lm_le << endl;
  // --------------------------------------------------

  // --------------------------------------------------
  CrossSection_EW_epem_to_mpmm_Eref = CrossSection_EW_epem_to_lplm(LEP_Eref, eemm_cos_p, eemm_cos_m, alpha_QED(alpha_EW_MZ, Mz2, pow(LEP_Eref,2)), g4cw2, M_z, G_z, cV_e, cA_e, cV_m, cA_m);
  cout << "LEP e+e- to m+m- at " << LEP_Eref << " GeV : " << CrossSection_EW_epem_to_mpmm_Eref*GeV2_to_pb << " pb " << endl;
  CrossSection_EW_epem_to_mpmm_mh = CrossSection_EW_epem_to_lplm(m_h, eemm_cos_p, eemm_cos_m, alpha_QED(alpha_EW_MZ, Mz2, pow(m_h,2)), g4cw2, M_z, G_z, cV_e, cA_e, cV_m, cA_m); 
  CrossSection_EW_epem_to_tptm_Eref = CrossSection_EW_epem_to_lplm(LEP_Eref, eett_cos_p, eett_cos_m, alpha_QED(alpha_EW_MZ, Mz2, pow(LEP_Eref,2)), g4cw2, M_z, G_z, cV_e, cA_e, cV_t, cA_t);
  CrossSection_EW_epem_to_tptm_mh = CrossSection_EW_epem_to_lplm(m_h, eett_cos_p, eett_cos_m, alpha_QED(alpha_EW_MZ, Mz2, pow(m_h,2)), g4cw2, M_z, G_z, cV_e, cA_e, cV_t, cA_t);
  // --------------------------------------------------

  // --------------------------------------------------
  // Mesons mixing
  box_S_WW = S_WW( pow( m_qt/M_w, 2) );
  cout << "Box SM, S_WW = " << box_S_WW << endl;
  // --------------------------------------------------
}
