#include <iostream> // Input/Output streams
#include <fstream>
#include <cmath> // Math fºs
#include <string> // Handle strings
#include <cstring> // Handle strings
#include <complex> // Complex numbers
#include <stdio.h> // Standard Input/Output
#include <gsl/gsl_rng.h> // Header for random number generation in gsl
#include <gsl/gsl_randist.h> // Header for distribution functions
#include <algorithm> // To use min,max with lists
#include <vector>

using namespace std;

// types
typedef double obs;
typedef complex<double>obs_c;
typedef unsigned long long LLint;


#include "../../mylib/prep-functions.h"
#include "../../mylib/gen_obj_class.h"
#include "../../mylib/chi2_obj_class.h"
#include "../../mylib/model_class.h"

int main()
{

  model_cls themodel("2HDM-glFC-I-re-SBS", "Z2 2HDM gFC lepton sector, type I quarks, real n's"); // declare object of model_cls class
  themodel.parallel_setup(1, 60); // .parallel_setup(i, j) creates subfolders i, i+1, ..., j for parallel runs

#include "../../myphyslib/2HDM-glFC/prep-I-re-SSB.cpp"

  themodel.create_all_files();
  return 0;
}


